package ex3;

import java.util.Collection;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.Semaphore;


public class MulticastProcess extends ReliableProcess {

	public MulticastProcess(int port) {
		super(port);
	}
	
	public void sendMulticast(Collection<Integer> group,final String message) {
		final Semaphore sem = new Semaphore(0);
		long start = System.currentTimeMillis();
		for (final Integer peer:group) {   
			/* TODO parallelize this Multicast.  Have a look at 
			 * Executors / ExecutorService to achieve this without creating a new Thread
			 * for each message. Creating Threads is costly and should therefore not 
			 * be done for simple tasks!
			*/
			//TODO Measure the time difference between your parallelized approach and the sequential one
			Runnable run = new Runnable() {
				public void run() {
					sendRMessage(peer, message);
					sem.release();
				}
			};
			run.run();
		}
		sem.acquireUninterruptibly(group.size());
		long end = System.currentTimeMillis();
		System.out.printf("%d ms needed for multicast of message \"%s\" ",(end-start),message);
	}

	@Override
	protected void rDeliver(int from, String message) {
	}

	


}
